//	Ella Roubtsova

package KPI3;

import com.metamaxim.modelscope.callbacks.*;
import java.util.*;


public class DashboardAccess extends Behaviour {
public Date getStartQuarter(){
			Calendar cal=Calendar.getInstance();
			Date StartQuarter = this. getDate("StartOfReportingQuarter"); 
			cal.setTime(StartQuarter);
			return StartQuarter;
}	
public Date getEndQuarter(){
			Calendar cal=Calendar.getInstance();
			Date StartQuarter = this. getDate("StartOfReportingQuarter"); 
			cal.add(Calendar.MONTH, 3); 
			Date EndQuarter=cal.getTime();;
			return EndQuarter;
			
//KPI 1 Population (Level of Need)
	public int  getLevelOfNeed() {
		int LevelOfNeed=0;
		//Date d =  new Date();	
		// choose the date three years ago
		Calendar cal = Calendar.getInstance();
        cal.add(Calendar.YEAR, -3);
        Date dd = cal.getTime();
	 
		Date Dashd = this. getDate("StartOfReportingQuarter");
		
		Instance[] existingSurvey =   selectInState("Survey", "@any");  
		  for (int i = 0; i < existingSurvey.length; i++) {
		  Date SD=existingSurvey[i].getDate("DateOfSurvey");
		  if (SD.compareTo(dd)>0 && SD.compareTo(Dashd)<0)
		  {LevelOfNeed=existingSurvey[i].getInteger("Population");
		   dd=SD;
		   }}
		return LevelOfNeed;
	}
//KPI 3a Number Of Referred Persons

public int  getNumberReferredPersons() {
		int NumberReferredPersons=0;
			
			Date StartRQ = getStartQuarter();
			Date EndRQ=getEndQuarter();;

		Instance[] referredPersons =   selectInState("ReferredPerson", "referred"); 
		for (int i = 0; i < referredPersons.length; i++) {
		  Date refDate=referredPersons[i].getDate("DateOfReferring");
		  if (refDate.compareTo(StartRQ)>=0 && refDate.compareTo(EndRQ)<=0 )		
			NumberReferredPersons+=1;}
		  return NumberReferredPersons;	
		  }
		  
			
		
//KPI 3b Number Referred Persons waited  28 days waited 
public int  getNumberReferredPersonsWaited() {
		int NumberReferredPersonsWaited=0;
			Calendar cal=Calendar.getInstance();
			Date StartRQ = this. getDate("StartOfReportingQuarter");
			cal.setTime(StartRQ);
			cal.add(Calendar.DATE, -28);
			Date Start28=cal.getTime();			
			// StartRQ + 3 months (quarter)
			cal.add(Calendar.MONTH, 3);
			Date EndRQ=cal.getTime();			
			
		Instance[] referredPersons =   selectInState("ReferredPerson", "referred"); 
		for (int i = 0; i < referredPersons.length; i++) {
		  Date refDate=referredPersons[i].getDate("DateOfReferring");
		  if (refDate.compareTo(Start28)>=0 && refDate.compareTo(EndRQ)<=0 )		
	 	NumberReferredPersonsWaited+=1;
		}
				 return NumberReferredPersonsWaited;	
		  }
	
// KPI 4=Number Of Entered Treatment (in state entered treatment and initially assessed) 

public int  getNumberOfEnteredTreatment() {
		int NumberOfEnteredTreatment=0;
			Calendar cal=Calendar.getInstance();
			Date StartRQ = this. getDate("StartOfReportingQuarter");
			cal.setTime(StartRQ);
			cal.add(Calendar.DATE, -28);
			Date Start28=cal.getTime();		
			// StartRQ + 3 months (quarter)
			cal.add(Calendar.MONTH, 3);
			Date EndRQ=cal.getTime();
		
		Instance[] enteredTreatment =   selectInState("ReferredPerson", "referred"); 
		for (int i = 0; i < enteredTreatment.length; i++) 
		{
		  Date refDate=enteredTreatment[i].getDate("DateOfReferring");
		  String treatmentState = enteredTreatment[i].getState("Treatment");
		  if (  refDate.compareTo(Start28)>=0 && refDate.compareTo(EndRQ)<=0 && (treatmentState.equals("entered") || treatmentState.equals("completed")) )		
			NumberOfEnteredTreatment+=1;
			}		
		  return NumberOfEnteredTreatment;	
		  }
// HI1 Access Rate KPI4/KPI1 
		  		  
public int  getAccessRate() { 
    int AccessRate=0;
    if 	(this.getInteger("LevelOfNeed")==0)
	{
	AccessRate=0;
	}
	else 
	{
	// whole percent
	AccessRate = (100*(this.getInteger("NumberOfEnteredTreatment")))/(this.getInteger("LevelOfNeed"));
    }
			return 	AccessRate;	
		  }	

		}	
	
 